import { ComplexDecimal } from './ComplexDecimal';
type StringQuote = '"' | "'";
declare class CharString {
    str: string;
    quote: StringQuote;
    static readonly STRING = 3;
    readonly type = 3;
    parent: any;
    constructor(str: string, quote?: StringQuote);
    static create(str: string, quote?: string): CharString;
    static copy(str: CharString): CharString;
    copy(): CharString;
    static parse(str: string): CharString;
    static unparse(value: CharString, parentPrecedence?: number): string;
    static unparseEscaped(value: CharString): string;
    static unparseMathML(value: CharString, parentPrecedence?: number): string;
    static unparseEscapedMathML(value: CharString): string;
    unparse(): string;
    unparseEscaped(): string;
    static toLogical(value: CharString): ComplexDecimal;
    toLogical(): ComplexDecimal;
}
export type { StringQuote };
export { CharString };
export default CharString;
