import { ComplexDecimal } from './ComplexDecimal';
import * as AST from './AST';
import { Evaluator } from './Evaluator';
declare class FunctionHandle {
    static readonly FUNCTION_HANDLE = 5;
    readonly type = 5;
    parent: any;
    id: string | null;
    commat: boolean;
    parameter: AST.NodeExpr[];
    expression: AST.NodeExpr;
    constructor(id?: string | null, commat?: boolean, parameter?: AST.NodeExpr[] | null, expression?: AST.NodeExpr);
    static newThis(id?: string | null, commat?: boolean, parameter?: AST.NodeExpr[] | null, expression?: AST.NodeExpr): FunctionHandle;
    static unparse(fhandle: FunctionHandle, evaluator: Evaluator, parentPrecedence?: number): string;
    static unparseMathML(fhandle: FunctionHandle, evaluator: Evaluator, parentPrecedence?: number): string;
    static copy(fhandle: FunctionHandle): FunctionHandle;
    copy(): FunctionHandle;
    static toLogical(fhandle: FunctionHandle): ComplexDecimal;
    toLogical(): ComplexDecimal;
}
export { FunctionHandle };
export default FunctionHandle;
